function setup()
	room.stackable = 0
	room.visible = 1
	
	--nebula
	room.addActor()
	actor.setpiece = 1
	--actor.setEffectIcon("rotteneggnebula.png")
	actor.setEffectIcon("esonebula.png")
	actor.randomizePlacement = 0
	actor.x = 15
	actor.y = 30
	actor.dist = 3
	actor.scale = 1
	actor.alpha = .7
	
	for i = 1, 20 do
		room.addActor()
		actor.setpiece = 1
		actor.setEffectIcon("nebulae1.png")
		actor.setRGB(255,150,150)
		actor.scale = .8 + math.random(1, 10) / 20
		actor.rot = math.random(0,359)
		actor.alpha = .05 + math.random() * .05
		actor.randomizePlacement = 0
		actor.x = 10
		actor.y = 26
		actor.jitterPlacement = 13
		actor.dist = 2 + math.random(1, 10) / 5
		actor.behavior = "slowspin"
	end
	
	--make the ruined planet beneath the green one, all sneaky-like
	room.addActor()
	--actor.setpiece = 1
	actor.setEffectIcon("mars1.png")
	actor.randomizePlacement = 0
	actor.x = 0
	actor.y = 0
	actor.scale = .15

	--so when this green one gets blown up the ruined one shows
	room.addActor()
	actor.nodeName = "VILE NEMESIS COLONY PLANET"
	actor.setEffectIcon("greenplanet.png")
	actor.randomizePlacement = 0
	actor.x = 0
	actor.y = 0
	actor.scale = .2
	actor.rot = 180
	actor.addTerrain("backdrop_greenplanet")
	
	--press a button to destroy the planet
	actor.addEvent("bigredbutton", 5)
	
	--needs to happen before adding mobs apparently?
	actor.addEvent("battlescript_bossbattle", 0)
	
	A = generator.getMobGroup("A")
	B = generator.getMobGroup("B")
	C = generator.getMobGroup("C")
	
	room.setWave(1)
	if generator.hardcore == 1 then
		room.addActor(B)
		room.addActor(A)
		room.addActor(A)
	end
	
	room.addActor()
	actor.nodeName = "WARNING : NEMESIS PASSIVE DEFENSE NETWORK"
	actor.displayName = "DODONGO"
	actor.setIcon("iconmobboss3.png")
	actor.addEvent("boss_dodongo", 0)
	if game.hardcore == 0 then actor.addWave("dodongo", 1, room.wave) else actor.addWave("dodongo", 1, room.wave, "hardcore") end
	--actor.addWave("dodongo", 1, room.wave)
	--wave.spawnmode = 2--don't warp in, just appear
	wave.tilex = 7
	wave.tiley = 10
	
	room.addActor()
	for i = 1, 3 do
		actor.addWave("bubblenode", 1, room.wave)
		--wave.spawnmode = 2--don't warp in, just appear
		wave.tilex = 2 + (i-1) * 5
		wave.tiley = 4 + math.mod(i, 2) * 8
		--generator.GFP("BUBBLENODE " .. wave.tilex .. "  " ..wave.tiley)
	end
	
	if generator.hardcore == 1 then
		room.setWave(2)
		room.addActor(B)
		room.addActor(A)
		room.setWave(3)
		room.addActor(C)
		room.addActor(A)
	end
	
	--full heal at conclusion of fight
	--room.addActor("fullheal.lua")
	if generator.hardcore == 1 then room.addActor("extralife.lua") end
	--if game.hardcore == 0 then room.addActor("extralife.lua") end
end